#ifdef VERTEX_SHADER


void main()
{
}

#endif

#ifdef GEOMETRY_SHADER

layout (points) in;
layout (triangle_strip, max_vertices = 3) out;
out vec2 uv;

void main(){
    gl_Position = vec4(-1.0, -1.0, 0.0, 1.0);
    uv = vec2(0.0, 0.0);
    EmitVertex();
    gl_Position = vec4(3.0, -1.0, 0.0, 1.0);
    uv = vec2(2.0, 0.0);
    EmitVertex();
    gl_Position = vec4(-1.0, 3.0, 0.0, 1.0);
    uv = vec2(0.0, 2.0);
    EmitVertex();
    EndPrimitive();
}

#endif

#ifdef FRAGMENT_SHADER

in vec2 uv;

uniform vec3 color;
uniform sampler2D colorTexture;
uniform sampler2D bloomTexture;
uniform sampler2D vol_light_texture;
//uniform sampler2D ssr_texture;

out vec4 FragColor;

float dither_pattern[16] = float[16] ( // bayer matrix
0.0f, 0.5f, 0.125f, 0.625f,
0.75f, 0.22f, 0.875f, 0.375f,
0.1875f, 0.6875f, 0.0625f, 0.5625,
0.9375f, 0.4375f, 0.8125f, 0.3125);

void main()
{
    const float gamma = 2.2;
    const float exposure = 1.0;
    vec3 color = texture(colorTexture, uv).rgb;
    vec3 bloom = texture(bloomTexture, uv).rgb;
    vec3 vol_light = texture(vol_light_texture, uv).rgb;

    vec3 result = 1 * color + 1 * bloom + vol_light * 1.0;
    //result = ssr_texture.rgb;
    // hdr
    result = vec3(1.0) - exp(-result * exposure);
    //result = result / (result + vec3(1.0));
    // gamma correction
    result = pow(result, vec3(1.0 / gamma));

    // To remove color banding
    float dither_value = 0.005 * (dither_pattern[ (int(gl_FragCoord.x) % 4)*4 + (int(gl_FragCoord.y)%4) ] - 0.5);
    //dither_value = 0.0;

    FragColor = vec4(result + dither_value, 1.0);
    //FragColor = ssr_color;
    //FragColor = vec4(ssr_color, 1.0);
    
    // UNUSED CODE SSR:
    //vec4 ssr_color = texture(ssr_texture, uv);
    //result = mix(result, ssr_color.rgb, ssr_color.a);
}

#endif
