#ifdef VERTEX_SHADER

void main()
{
}

#endif

#ifdef GEOMETRY_SHADER

layout (points) in;
layout (triangle_strip, max_vertices = 3) out;
out vec2 uv;

void main(){
    gl_Position = vec4(-1.0, -1.0, 0.0, 1.0);
    uv = vec2(0.0, 0.0);
    EmitVertex();
    gl_Position = vec4(3.0, -1.0, 0.0, 1.0);
    uv = vec2(2.0, 0.0);
    EmitVertex();
    gl_Position = vec4(-1.0, 3.0, 0.0, 1.0);
    uv = vec2(0.0, 2.0);
    EmitVertex();
    EndPrimitive();
}

#endif

#ifdef FRAGMENT_SHADER

in vec2 uv;

uniform sampler2D image;

uniform bool horizontal;
uniform float kernel[5] = float[] (0.2270270270, 0.1945945946, 0.1216216216, 0.0540540541, 0.0162162162);

out vec4 FragColor;

void main()
{
    vec2 tex_offset = 1.0 / textureSize(image, 0); 
    vec3 result = texture(image, uv).rgb * kernel[0];
    if(horizontal)
    {
        for(int i = 1; i < 5; ++i)
        {
           result += texture(image, uv + vec2(tex_offset.x * i, 0.0)).rgb * kernel[i];
           result += texture(image, uv - vec2(tex_offset.x * i, 0.0)).rgb * kernel[i];
        }
    }
    else
    {
        for(int i = 1; i < 5; ++i)
        {
            result += texture(image, uv + vec2(0.0, tex_offset.y * i)).rgb * kernel[i];
            result += texture(image, uv - vec2(0.0, tex_offset.y * i)).rgb * kernel[i];
        }
    }
    FragColor = vec4(result, 1.0);
}

#endif